<cfcomponent 
	extends="core"
	displayname="agent" 
	hint="performs functions" >
	<cfsetting showdebugoutput="yes">	
          				         
          
            <cffunction
            name="validate_file" 
            output="true"
            returntype="string"
            hint="validates file format and loads the file into the dialer" 
            access="public">
            <cfargument name="file_name" default="" required="yes">
            
            <cfset error_message = "">
            <cfset fail_message = "">
            <cfset ticker = 0> 
            <cfset today = dateformat(now(),"mm_dd_yy")>
            <cfset entry_date = now()>
            <cfset this_year = "#year(now())#">
            <cfset the_file = "#application.temp_upload##file_name#"> 
            <cfset list_id = "#application.vici_list_id#">
            
            <!--- Establish if daylight savings is in place...--->
            <cfset SSM = "#GetNthOccOfDayInMonth(2,1,3,this_year)#">
            <cfset SSM = "3/#SSM#/#year(now())#">
            <cfset FSN = "#GetNthOccOfDayInMonth(1,1,11,this_year)#"> 
            <cfset FSN = "11/#FSN#/#year(now())#">
            <cfset in_DST = "#IsDateBetween(entry_date, SSM, FSN)#">
            
            
            <!--- Set up the variables we expect form the file to be loaded --->
            <cfparam name="trcode" default="">
            <cfparam name="city" default="">
            <cfparam name="name" default="">
            <cfparam name="account" default="">
            <cfparam name="total_due" default="">
            <cfparam name="past_due" default="">
            <cfparam name="cycle" default="">
            <cfparam name="phone" default="">
            
            
            <!---Get the GMT offset data to use in the loop'n load below--->
            <cfinvoke component="functions.db_loader_unloader" method="get_GMT_offset" returnvariable="Gmt_data">
            
            <!---Unload the previous List--->
            <cfinvoke component="functions.db_loader_unloader" method="delete_vicidial_list" list_id="#list_id#">
            
            <!---Unload the hopper--->
            <cfinvoke component="functions.db_loader_unloader" method="delete_vicidial_hopper" list_id="#list_id#">
            
            
            
            <!--- FIRST check the header row to see if it matches the defined header row --->
            <cfloop  
            index = "x" 
            file="#the_file#" from="1" to="1">
            <cfset row = csvToArray(csv = trim( x )) />
            <cfset the_length = arraylen(row[1])>
                
                <!--- check the array length of the header row. --->
                <cfif the_length is 8>
                    <cfset file_header = ReReplace(x, "[[:space:]]","","ALL")>
                    <cfset defined_header = ReReplace(application.header_row, "[[:space:]]","","ALL")>
                    <cfif listdiff(file_header,defined_header) neq "">
                        <font style="font-weight:bold;" color="##990000">ERROR! Process Aborted...Invalid Header Row:</font><br>
                         <strong>Uploaded Header Row:</strong><Br>#x#
                         <br><br>
                         <strong>Does Not Match Required Header Row:</strong><BR>
                         #application.header_row#  
                        <br><br>
                        Please ensure your upload is a valid .csv file and that the header row matches the required format. 
                        <br><bR>
                        <cftry>
                        <!--- Delete the file --->
                        <cffile action="delete" file="#application.temp_upload##file_name#" >
                        <cfcatch type="any">
                        </cfcatch>
                        </cftry>
                    <cfabort>
                    </cfif> 
                 <cfelse>
                    <font style="font-weight:bold;" color="##990000">ERROR! Process Aborted...Invalid Header Row:</font><br>
                     <strong>Uploaded Header Row:</strong><Br>#x#
                     <br><br>
                     <strong>Does Not Match Required Header Row:</strong><BR>
                     #application.header_row#  
                    <br><br>
                    Please ensure your upload is a valid .csv file and that the header row matches the required format. 
                    <br><bR> 
                    <cftry>
                    <!--- Delete the file --->
                    <cffile action="delete" file="#application.temp_upload##file_name#" >
                    <cfcatch type="any">
                    </cfcatch>
                    </cftry>
                    <cfabort>   
                </cfif>
            </cfloop>
            <!--- End Header row check --->
            
            
            <!--- The header row passed inspection... now loop over the data and validate it. --->
            <cfloop  
            index = "x" 
            file="#the_file#" from="2"> 
            
            <cfset row = csvToArray(csv = trim( x )) />
            <cfset the_length = arraylen(row[1])>
            
                <cfif the_length is 8>
                    <!--- map the variables to the array --->
                    <cfset trcode = "#row[1][1]#">
                    <cfset city = "#row[1][2]#">
                    <cfset name = "#row[1][3]#">
                    <cfset account = "#row[1][4]#">
                    <cfset total_due = "#row[1][5]#">
                    <cfset past_due = "#row[1][6]#">
                    <cfset cycle = "#row[1][7]#">
                    <cfset phone = "#row[1][8]#">
                    <cfset phone = phoneformat(phone,"xxxxxxxx")>
                    
                    <!--- Validate for mandatory fields and format... PHONE is always validated --->
                    <cfif len(phone) neq 10 or isnumeric(phone) is false>
                        <cfset error_message = listappend(error_message,x,"^")>
                    <cfelse>
                        <cfif len(name) gt 29> 
                          <cfset name = right(name,30)>
                        </cfif>
                        <!--- Ok Load the row.  --->
                        <!---First we have to get the GMT offset--->
                        <cfset area_code = left(phone,3)>
                        
                        <!--- QUery of Quries to get the GMT offset for the areacode. --->
                        <cfquery name="check_code" dbtype="query">
                            Select GMT_offset, DST
                            From GMT_data
                            Where areacode = <cfqueryparam cfsqltype="cf_sql_varchar" value="#area_code#">
                        </cfquery>
                        
                        <cfif check_code.DST is 'Y' and in_DST is "YES">
                            <cfset the_GMT = (#check_code.GMT_offset# + 1)>
                        <cfelse> 
                            <cfset the_GMT = #check_code.GMT_offset# >
                        </cfif>
                        
                        <cfset GMT_offset = "#the_GMT#">
                        
                         <!---Good, now load the data into the vicidial DB--->
                        <cftry>
                           <cfquery name="load2" datasource="#application.vici_datasource#"> 
                                INSERT INTO vicidial_list
                                Set
                                entry_date = <cfqueryparam cfsqltype="cf_sql_timestamp" value="#entry_date#">,
                                modify_date =  <cfqueryparam cfsqltype="cf_sql_timestamp" value="#entry_date#">,
                                status = <cfqueryparam cfsqltype="cf_sql_varchar" value="NEW">,
                                user = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                vendor_lead_code = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                source_id = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                list_id = <cfqueryparam cfsqltype="cf_sql_integer" value="#list_id#">,
                                gmt_offset_now = <cfqueryparam cfsqltype="cf_sql_decimal" value="#GMT_offset#">,
                                called_since_last_reset = <cfqueryparam cfsqltype="cf_sql_varchar" value="N">,
                                phone_code = <cfqueryparam cfsqltype="cf_sql_varchar" value="1">,
                                phone_number = <cfqueryparam cfsqltype="cf_sql_varchar" value="#phone#">, 
                                title = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                first_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="#name#">,
                                middle_initial = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                last_name = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                address1 = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                address2 = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                address3 = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                city  = <cfqueryparam cfsqltype="cf_sql_varchar" value="#city#">,
                                state  = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                province  = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                postal_code  = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                country_code  = <cfqueryparam cfsqltype="cf_sql_varchar" value="">,
                                gender = 'U',
                                date_of_birth = '0000-00-00',
                                alt_phone = <cfqueryparam  cfsqltype="cf_sql_varchar" value="">,
                                email = <cfqueryparam  cfsqltype="cf_sql_varchar" value="">,
                                security_phrase = <cfqueryparam  cfsqltype="cf_sql_varchar" value="">,
                                comments = <cfqueryparam  cfsqltype="cf_sql_varchar" value="">,
                                called_count = <cfqueryparam  cfsqltype="cf_sql_varchar" value="0">,                            
                                rank = <cfqueryparam  cfsqltype="cf_sql_varchar" value="0">,
                                owner = <cfqueryparam  cfsqltype="cf_sql_varchar" value="">,
                                entry_list_id = <cfqueryparam  cfsqltype="cf_sql_varchar" value="0">
                            </cfquery>   
                        <cfcatch type="any">
                            <cfset fail_message = listappend(fail_message,"Error loading file into dialer. Failed on file row: #ticker#","^") >
                            <cfset error_message = listappend(error_message,x,"^")>
                            <cfset ticker = (ticker - 1)>
                            <cfbreak>
                        </cfcatch>
                        </cftry>  
                        
                        <cfset ticker = (ticker + 1)>
                
                    </cfif>
                <cfelse>
                    <!--- The array lenght of the row was not 8... document error... --->
                    <cfset error_message = listappend(error_message,x,"^")>
                </cfif>
            </cfloop>
            
            <cfset error_message = listappend(error_message,fail_message,"^")>
            <cfset error_message = listappend(error_message,ticker,"^")>
            
            <!--- move the file to the loaded leads folder and rename it--->
            <cffile action="move" source="#application.temp_upload##file_name#" destination="#application.loaded_leads#loaded_#today#.csv">
            
            <cfreturn error_message />       
            </cffunction>

          
</cfcomponent>